/* GeoLocate.c generated by valac 0.47.3, the Vala compiler
 * generated from GeoLocate.vala, do not modify */

/*
* Copyright (c) 2017-2018 Carlos Suárez (https://gitlab.com/bitseater)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; If not, see <http://www.gnu.org/licenses/>.
*
* Authored by: Carlos Suárez <bitseater@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <geocode-glib/geocode-glib.h>
#include <libsoup/soup.h>
#include <json-glib/json-glib.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>

#define METEO_UTILS_TYPE_COORD (meteo_utils_coord_get_type ())
typedef struct _MeteoUtilsCoord MeteoUtilsCoord;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_SoupBuffer_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupBuffer_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

struct _MeteoUtilsCoord {
	gdouble lat;
	gdouble lon;
};

GType meteo_utils_coord_get_type (void) G_GNUC_CONST;
MeteoUtilsCoord* meteo_utils_coord_dup (const MeteoUtilsCoord* self);
void meteo_utils_coord_free (MeteoUtilsCoord* self);
void meteo_utils_geolocate (void);
#define CONSTANTS_OWM_API_ADDR "http://api.openweathermap.org/data/2.5/"
void meteo_utils_get_location (MeteoUtilsCoord* result);
gint64 meteo_utils_update_id (const gchar* uri);
static void _vala_SoupBuffer_free (SoupBuffer* self);

MeteoUtilsCoord*
meteo_utils_coord_dup (const MeteoUtilsCoord* self)
{
	MeteoUtilsCoord* dup;
	dup = g_new0 (MeteoUtilsCoord, 1);
	memcpy (dup, self, sizeof (MeteoUtilsCoord));
	return dup;
}

void
meteo_utils_coord_free (MeteoUtilsCoord* self)
{
	g_free (self);
}

static GType
meteo_utils_coord_get_type_once (void)
{
	GType meteo_utils_coord_type_id;
	meteo_utils_coord_type_id = g_boxed_type_register_static ("MeteoUtilsCoord", (GBoxedCopyFunc) meteo_utils_coord_dup, (GBoxedFreeFunc) meteo_utils_coord_free);
	return meteo_utils_coord_type_id;
}

GType
meteo_utils_coord_get_type (void)
{
	static volatile gsize meteo_utils_coord_type_id__volatile = 0;
	if (g_once_init_enter (&meteo_utils_coord_type_id__volatile)) {
		GType meteo_utils_coord_type_id;
		meteo_utils_coord_type_id = meteo_utils_coord_get_type_once ();
		g_once_init_leave (&meteo_utils_coord_type_id__volatile, meteo_utils_coord_type_id);
	}
	return meteo_utils_coord_type_id__volatile;
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}

void
meteo_utils_geolocate (void)
{
	GSettings* setting = NULL;
	GSettings* _tmp0_;
	gchar* uri1 = NULL;
	gchar* _tmp1_;
	gchar* uri2 = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	MeteoUtilsCoord mycoords = {0};
	MeteoUtilsCoord _tmp6_ = {0};
	GeocodeLocation* location = NULL;
	MeteoUtilsCoord _tmp7_;
	MeteoUtilsCoord _tmp8_;
	GeocodeLocation* _tmp9_;
	GeocodeReverse* reverse = NULL;
	GeocodeReverse* _tmp10_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = g_settings_new ("com.gitlab.bitseater.meteo");
	setting = _tmp0_;
	_tmp1_ = g_strdup (CONSTANTS_OWM_API_ADDR "weather?lat=");
	uri1 = _tmp1_;
	_tmp2_ = g_settings_get_string (setting, "apiid");
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat ("&APPID=", _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	uri2 = _tmp5_;
	meteo_utils_get_location (&_tmp6_);
	mycoords = _tmp6_;
	_tmp7_ = mycoords;
	_tmp8_ = mycoords;
	_tmp9_ = geocode_location_new (_tmp7_.lat, _tmp8_.lon, (gdouble) GEOCODE_LOCATION_ACCURACY_UNKNOWN);
	location = _tmp9_;
	_tmp10_ = geocode_reverse_new_for_location (location);
	reverse = _tmp10_;
	{
		GeocodePlace* mycity = NULL;
		GeocodePlace* _tmp11_;
		_tmp11_ = geocode_reverse_resolve (reverse, &_inner_error0_);
		mycity = _tmp11_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		if (mycity != NULL) {
			gchar* uri = NULL;
			MeteoUtilsCoord _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			MeteoUtilsCoord _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			const gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			const gchar* _tmp29_;
			const gchar* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			_tmp12_ = mycoords;
			_tmp13_ = double_to_string (_tmp12_.lat);
			_tmp14_ = _tmp13_;
			_tmp15_ = g_strconcat (uri1, _tmp14_, NULL);
			_tmp16_ = _tmp15_;
			_tmp17_ = g_strconcat (_tmp16_, "&lon=", NULL);
			_tmp18_ = _tmp17_;
			_tmp19_ = mycoords;
			_tmp20_ = double_to_string (_tmp19_.lon);
			_tmp21_ = _tmp20_;
			_tmp22_ = g_strconcat (_tmp18_, _tmp21_, NULL);
			_tmp23_ = _tmp22_;
			_tmp24_ = g_strconcat (_tmp23_, uri2, NULL);
			_tmp25_ = _tmp24_;
			_g_free0 (_tmp23_);
			_g_free0 (_tmp21_);
			_g_free0 (_tmp18_);
			_g_free0 (_tmp16_);
			_g_free0 (_tmp14_);
			uri = _tmp25_;
			_tmp26_ = uri;
			_tmp27_ = g_strdup_printf ("%" G_GINT64_FORMAT, meteo_utils_update_id (_tmp26_));
			_tmp28_ = _tmp27_;
			g_settings_set_string (setting, "idplace", _tmp28_);
			_g_free0 (_tmp28_);
			_tmp29_ = geocode_place_get_town (mycity);
			_tmp30_ = _tmp29_;
			g_settings_set_string (setting, "location", _tmp30_);
			_tmp31_ = geocode_place_get_state (mycity);
			_tmp32_ = _tmp31_;
			g_settings_set_string (setting, "state", _tmp32_);
			_tmp33_ = geocode_place_get_country_code (mycity);
			_tmp34_ = _tmp33_;
			g_settings_set_string (setting, "country", _tmp34_);
			_g_free0 (uri);
		}
		_g_object_unref0 (mycity);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp35_;
		const gchar* _tmp36_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp35_ = e;
		_tmp36_ = _tmp35_->message;
		g_debug ("GeoLocate.vala:45: %s", _tmp36_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (reverse);
		_g_object_unref0 (location);
		_g_free0 (uri2);
		_g_free0 (uri1);
		_g_object_unref0 (setting);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (reverse);
	_g_object_unref0 (location);
	_g_free0 (uri2);
	_g_free0 (uri1);
	_g_object_unref0 (setting);
}

static void
_vala_SoupBuffer_free (SoupBuffer* self)
{
	g_boxed_free (soup_buffer_get_type (), self);
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

void
meteo_utils_get_location (MeteoUtilsCoord* result)
{
	MeteoUtilsCoord coord = {0};
	gchar* uri = NULL;
	gchar* _tmp0_;
	SoupSession* session = NULL;
	SoupSession* _tmp1_;
	SoupMessage* message = NULL;
	const gchar* _tmp2_;
	SoupMessage* _tmp3_;
	SoupSession* _tmp4_;
	SoupMessage* _tmp5_;
	GError* _inner_error0_ = NULL;
	memset (&coord, 0, sizeof (MeteoUtilsCoord));
	_tmp0_ = g_strdup ("https://location.services.mozilla.com/v1/geolocate?key=test");
	uri = _tmp0_;
	_tmp1_ = soup_session_new ();
	session = _tmp1_;
	_tmp2_ = uri;
	_tmp3_ = soup_message_new ("GET", _tmp2_);
	message = _tmp3_;
	_tmp4_ = session;
	_tmp5_ = message;
	soup_session_send_message (_tmp4_, _tmp5_);
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp6_;
		JsonParser* _tmp7_;
		SoupMessage* _tmp8_;
		SoupMessageBody* _tmp9_;
		SoupBuffer* _tmp10_;
		SoupBuffer* _tmp11_;
		guint8* _tmp12_;
		gint _tmp12__length1;
		JsonObject* root = NULL;
		JsonParser* _tmp13_;
		JsonNode* _tmp14_;
		JsonObject* _tmp15_;
		JsonObject* _tmp16_;
		JsonObject* _tmp17_;
		GList* _tmp18_;
		_tmp6_ = json_parser_new ();
		parser = _tmp6_;
		_tmp7_ = parser;
		_tmp8_ = message;
		_tmp9_ = _tmp8_->response_body;
		_tmp10_ = soup_message_body_flatten (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = _tmp11_->data;
		_tmp12__length1 = _tmp11_->length;
		json_parser_load_from_data (_tmp7_, (const gchar*) _tmp12_, (gssize) -1, &_inner_error0_);
		__vala_SoupBuffer_free0 (_tmp11_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (parser);
			goto __catch1_g_error;
		}
		_tmp13_ = parser;
		_tmp14_ = json_parser_get_root (_tmp13_);
		_tmp15_ = json_node_get_object (_tmp14_);
		_tmp16_ = _json_object_ref0 (_tmp15_);
		root = _tmp16_;
		_tmp17_ = root;
		_tmp18_ = json_object_get_members (_tmp17_);
		{
			GList* name_collection = NULL;
			GList* name_it = NULL;
			name_collection = _tmp18_;
			for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
				gchar* _tmp19_;
				gchar* name = NULL;
				_tmp19_ = g_strdup ((const gchar*) name_it->data);
				name = _tmp19_;
				{
					const gchar* _tmp20_;
					_tmp20_ = name;
					if (g_strcmp0 (_tmp20_, "location") == 0) {
						JsonObject* mycoords = NULL;
						JsonObject* _tmp21_;
						JsonObject* _tmp22_;
						JsonObject* _tmp23_;
						JsonObject* _tmp24_;
						JsonObject* _tmp25_;
						_tmp21_ = root;
						_tmp22_ = json_object_get_object_member (_tmp21_, "location");
						_tmp23_ = _json_object_ref0 (_tmp22_);
						mycoords = _tmp23_;
						_tmp24_ = mycoords;
						coord.lat = json_object_get_double_member (_tmp24_, "lat");
						_tmp25_ = mycoords;
						coord.lon = json_object_get_double_member (_tmp25_, "lng");
						_json_object_unref0 (mycoords);
						_g_free0 (name);
						break;
					} else {
						FILE* _tmp26_;
						_tmp26_ = stdout;
						fprintf (_tmp26_, "%s", _ ("Found an error"));
					}
					_g_free0 (name);
				}
			}
			(name_collection == NULL) ? NULL : (name_collection = (g_list_free (name_collection), NULL));
		}
		_json_object_unref0 (root);
		_g_object_unref0 (parser);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp27_ = e;
		_tmp28_ = _tmp27_->message;
		g_debug ("GeoLocate.vala:73: %s", _tmp28_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		_g_free0 (uri);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	*result = coord;
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	_g_free0 (uri);
	return;
}

gint64
meteo_utils_update_id (const gchar* uri)
{
	SoupSession* session = NULL;
	SoupSession* _tmp0_;
	SoupMessage* message = NULL;
	SoupMessage* _tmp1_;
	gint64 id = 0LL;
	GError* _inner_error0_ = NULL;
	gint64 result = 0LL;
	g_return_val_if_fail (uri != NULL, 0LL);
	_tmp0_ = soup_session_new ();
	session = _tmp0_;
	_tmp1_ = soup_message_new ("GET", uri);
	message = _tmp1_;
	soup_session_send_message (session, message);
	id = (gint64) 0;
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp2_;
		SoupMessageBody* _tmp3_;
		SoupBuffer* _tmp4_;
		SoupBuffer* _tmp5_;
		guint8* _tmp6_;
		gint _tmp6__length1;
		JsonObject* root = NULL;
		JsonNode* _tmp7_;
		JsonObject* _tmp8_;
		JsonObject* _tmp9_;
		JsonObject* _tmp10_;
		_tmp2_ = json_parser_new ();
		parser = _tmp2_;
		_tmp3_ = message->response_body;
		_tmp4_ = soup_message_body_flatten (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_->data;
		_tmp6__length1 = _tmp5_->length;
		json_parser_load_from_data (parser, (const gchar*) _tmp6_, (gssize) -1, &_inner_error0_);
		__vala_SoupBuffer_free0 (_tmp5_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (parser);
			goto __catch2_g_error;
		}
		_tmp7_ = json_parser_get_root (parser);
		_tmp8_ = json_node_get_object (_tmp7_);
		_tmp9_ = _json_object_ref0 (_tmp8_);
		root = _tmp9_;
		_tmp10_ = root;
		id = json_object_get_int_member (_tmp10_, "id");
		_json_object_unref0 (root);
		_g_object_unref0 (parser);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		g_debug ("GeoLocate.vala:89: %s", _tmp12_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint64 _tmp13_ = -1LL;
		_g_object_unref0 (message);
		_g_object_unref0 (session);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp13_;
	}
	result = id;
	_g_object_unref0 (message);
	_g_object_unref0 (session);
	return result;
}

